Package com.tibco.patterns.learn.training

## Interface TrainingObserver

- All Known Subinterfaces:
    `ConvergenceObserver`
  All Known Implementing Classes:
    `COErrorRate`, `COErrorRateMin`, `COIterationCount`, `COScoreChange`

      public interface TrainingObserver

  Defines an object that gathers training statistics for a certain dataset.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `beginIteration()` | Resets internal state to prepare for a new iteration of evaluating the entire dataset.
    `void` | `endIteration()` | Any actions that need to be performed after evaluating the dataset.
    `void` | `evaluatePrediction​(VectorExample e)` | Interprets or accumulates prediction result of a single feature vector Called once for each feature vector in the dataset
    `boolean` | `hasIterations()` |
    `boolean` | `isPerfectResult()` |

- - ### Method Detail

    - #### beginIteration

          void beginIteration()

      Resets internal state to prepare for a new iteration of evaluating the entire dataset. Can also be used to report progress before every training iteration.

    - #### evaluatePrediction

          void evaluatePrediction​(VectorExample e)

      Interprets or accumulates prediction result of a single feature vector Called once for each feature vector in the dataset
      Parameters:
        `e` - - an example that must have the RLink prediction assigned.

    - #### endIteration

          void endIteration()

      Any actions that need to be performed after evaluating the dataset. E.g. report progress in GUI.

    - #### isPerfectResult

          boolean isPerfectResult()

      Returns:
        true if the model fits the training data perfectly and therefore its predictions cannot be improved. Any further training with the same data is futile.

    - #### hasIterations

          boolean hasIterations()

      Returns:
        true if any training iterations have been done using this observer.